Subject: Re: [PATCH 0/2] net: introduce IFF_NO_QUEUE as successor of zero tx_queue_len

From: Jesper Dangaard Brouer <[email-masked]>
Date: Mon, 17 Aug 2015 17:16:03 +0200

On Mon, 17 Aug 2015 06:44:51 -0700
Eric Dumazet <[email-masked]> wrote:

> On Mon, 2015-08-17 at 08:51 +0200, Jesper Dangaard Brouer wrote:
> > On Fri, 14 Aug 2015 10:41:53 +0200 Phil Sutter <[email-masked]> wrote:
> > 
> > > On Thu, Aug 13, 2015 at 12:11:57PM -0700, Stephen Hemminger wrote:
> > [...]
> > > > 
> > > > But adding a flag risks breaking external scripts.
> > > 
> > > Could you please elaborate on this? As far as I can tell, introducing a
> > > separate flag is the only solution *not* breaking existing scripts. So
> > > if you see the rub, I would like to know where exactly it is.
> > 
> > I agree with Phil.  AFAIC see this approach does not break existing
> > scripts.
> > 
> > Acked-by: Jesper Dangaard Brouer <[email-masked]>
> > 
> 
> But, what is the long term plan ?
> 
> If long term plan is to change veth txqueuelen to 0, we said no.
> (because it is too late and this change will break some setups)

No, veth keep txqueuelen at the default 1000.  We simply add the flag
IFF_NO_QUEUE to veth. 

That result in (1) veth gets no-qdisc when using the default qdisc, and
(2) if anyone assigns another qdisc it still works.  This is backward
compatible with existing scripts.

Long term plan is to change e.g. vlan to be marked with IFF_NO_QUEUE
and don't set txqueuelen to zero (automatic falls back to default
setting).  This avoids any gotchas for users assigning a qdisc. This is
also backward compatible, with users who know to change the txqueuelen
before assigning a qdisc to a vlan.

-- 
Best regards,
  Jesper Dangaard Brouer
  MSc.CS, Sr. Network Kernel Developer at Red Hat
  Author of http://www.iptv-analyzer.org
  LinkedIn: http://www.linkedin.com/in/brouer